--- libLAS-1.8.1/src/gt_citation.cpp	2023-09-12 20:29:39.121340647 +0900
+++ libLAS-1.8.1-fix/src/gt_citation.cpp	2023-09-12 21:03:27.251212266 +0900
@@ -155,7 +155,7 @@
         if(p1[0] == '\0' || p1[0] == '\n' || p1[0] == ' ')
           p1 --;
         p2 = p1 - 1;
-        while( p2>0 && (p2[0] == ' ' || p2[0] == '\0' || p2[0] == '\n') )
+        while( p2!=nullptr && (p2[0] == ' ' || p2[0] == '\0' || p2[0] == '\n') )
           p2--;
         if(p2 != p1 - 1)
           p1 = p2;
@@ -198,7 +198,7 @@
         if(p1[0] == '\0' || p1[0] == '\n' || p1[0] == ' ')
           p1 --;
         char* p2 = p1 - 1;
-        while( p2>0 && (p2[0] == ' ' || p2[0] == '\0' || p2[0] == '\n') )
+        while( p2!=nullptr && (p2[0] == ' ' || p2[0] == '\0' || p2[0] == '\n') )
           p2--;
         if(p2 != p1 - 1)
           p1 = p2;
@@ -387,10 +387,10 @@
         osCitation += primemName;
         bRewriteGeogCitation = TRUE;
 
-        double primemValue = poSRS->GetPrimeMeridian(NULL);
+        double primemValue = poSRS->GetPrimeMeridian(nullptr);
         if(angUnitName && !EQUAL(angUnitName, "Degree"))
         {
-            double aUnit = poSRS->GetAngularUnits(NULL);
+            double aUnit = poSRS->GetAngularUnits(nullptr);
             primemValue *= aUnit;
         }
         GTIFKeySet( psGTIF, GeogPrimeMeridianLongGeoKey, TYPE_DOUBLE, 1, 
@@ -461,7 +461,7 @@
                 break;
             }
       }
-      if( unitSize == 0.0 )
+      if( std::abs(unitSize - 0.0) < std::numeric_limits<double>::epsilon() )
         GTIFKeyGet(hGTIF, ProjLinearUnitSizeGeoKey, &unitSize, 0,
                          sizeof(unitSize) );
       poSRS->SetLinearUnits( ctNames[CitLUnitsName], unitSize);
--- libLAS-1.8.1/src/c_api.cpp	2023-09-12 20:29:39.528007288 +0900
+++ libLAS-1.8.1-fix/src/c_api.cpp	2023-09-12 21:22:42.577805783 +0900
@@ -498,7 +498,7 @@
         
         transforms.erase( std::remove_if( transforms.begin(), 
                                   transforms.end(),
-                                  boost::bind( &IsReprojectionTransform, _1 ) ),
+                                  boost::bind( &IsReprojectionTransform, boost::placeholders::_1 ) ),
                   transforms.end());
         
         liblas::TransformPtr srs_transform = liblas::TransformPtr(new liblas::ReprojectionTransform(in_ref, *out_ref, &h));
@@ -1840,7 +1840,7 @@
         
         transforms.erase( std::remove_if( transforms.begin(), 
                                   transforms.end(),
-                                  boost::bind( &IsReprojectionTransform, _1 ) ),
+                                  boost::bind( &IsReprojectionTransform, boost::placeholders::_1 ) ),
                   transforms.end());
         
         liblas::TransformPtr srs_transform = liblas::TransformPtr(new liblas::ReprojectionTransform(in_ref, *out_ref, &h));
